// ============================================================================
//
// Copyright (c) 2006-2015, Talend Inc.
//
// This source code has been automatically generated by_Talend Open Studio for Data Integration
// / Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package bi.accident_fact_0_1;

import routines.Numeric;
import routines.DataOperation;
import routines.TalendDataGenerator;
import routines.TalendStringUtil;
import routines.TalendString;
import routines.StringHandling;
import routines.Relational;
import routines.TalendDate;
import routines.Mathematical;
import routines.system.*;
import routines.system.api.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.math.BigDecimal;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.util.Comparator;

@SuppressWarnings("unused")

/**
 * Job: accident_fact Purpose: <br>
 * Description: <br>
 * 
 * @author user@talend.com
 * @version 7.3.1.20200219_1130
 * @status
 */
public class accident_fact implements TalendJob {

	protected static void logIgnoredError(String message, Throwable cause) {
		System.err.println(message);
		if (cause != null) {
			cause.printStackTrace();
		}

	}

	public final Object obj = new Object();

	// for transmiting parameters purpose
	private Object valueObject = null;

	public Object getValueObject() {
		return this.valueObject;
	}

	public void setValueObject(Object valueObject) {
		this.valueObject = valueObject;
	}

	private final static String defaultCharset = java.nio.charset.Charset.defaultCharset().name();

	private final static String utf8Charset = "UTF-8";

	// contains type for every context property
	public class PropertiesWithType extends java.util.Properties {
		private static final long serialVersionUID = 1L;
		private java.util.Map<String, String> propertyTypes = new java.util.HashMap<>();

		public PropertiesWithType(java.util.Properties properties) {
			super(properties);
		}

		public PropertiesWithType() {
			super();
		}

		public void setContextType(String key, String type) {
			propertyTypes.put(key, type);
		}

		public String getContextType(String key) {
			return propertyTypes.get(key);
		}
	}

	// create and load default properties
	private java.util.Properties defaultProps = new java.util.Properties();

	// create application properties with default
	public class ContextProperties extends PropertiesWithType {

		private static final long serialVersionUID = 1L;

		public ContextProperties(java.util.Properties properties) {
			super(properties);
		}

		public ContextProperties() {
			super();
		}

		public void synchronizeContext() {

		}

	}

	protected ContextProperties context = new ContextProperties(); // will be instanciated by MS.

	public ContextProperties getContext() {
		return this.context;
	}

	private final String jobVersion = "0.1";
	private final String jobName = "accident_fact";
	private final String projectName = "BI";
	public Integer errorCode = null;
	private String currentComponent = "";

	private final java.util.Map<String, Object> globalMap = new java.util.HashMap<String, Object>();
	private final static java.util.Map<String, Object> junitGlobalMap = new java.util.HashMap<String, Object>();

	private final java.util.Map<String, Long> start_Hash = new java.util.HashMap<String, Long>();
	private final java.util.Map<String, Long> end_Hash = new java.util.HashMap<String, Long>();
	private final java.util.Map<String, Boolean> ok_Hash = new java.util.HashMap<String, Boolean>();
	public final java.util.List<String[]> globalBuffer = new java.util.ArrayList<String[]>();

	private RunStat runStat = new RunStat();

	// OSGi DataSource
	private final static String KEY_DB_DATASOURCES = "KEY_DB_DATASOURCES";

	private final static String KEY_DB_DATASOURCES_RAW = "KEY_DB_DATASOURCES_RAW";

	public void setDataSources(java.util.Map<String, javax.sql.DataSource> dataSources) {
		java.util.Map<String, routines.system.TalendDataSource> talendDataSources = new java.util.HashMap<String, routines.system.TalendDataSource>();
		for (java.util.Map.Entry<String, javax.sql.DataSource> dataSourceEntry : dataSources.entrySet()) {
			talendDataSources.put(dataSourceEntry.getKey(),
					new routines.system.TalendDataSource(dataSourceEntry.getValue()));
		}
		globalMap.put(KEY_DB_DATASOURCES, talendDataSources);
		globalMap.put(KEY_DB_DATASOURCES_RAW, new java.util.HashMap<String, javax.sql.DataSource>(dataSources));
	}

	private final java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream();
	private final java.io.PrintStream errorMessagePS = new java.io.PrintStream(new java.io.BufferedOutputStream(baos));

	public String getExceptionStackTrace() {
		if ("failure".equals(this.getStatus())) {
			errorMessagePS.flush();
			return baos.toString();
		}
		return null;
	}

	private Exception exception;

	public Exception getException() {
		if ("failure".equals(this.getStatus())) {
			return this.exception;
		}
		return null;
	}

	private class TalendException extends Exception {

		private static final long serialVersionUID = 1L;

		private java.util.Map<String, Object> globalMap = null;
		private Exception e = null;
		private String currentComponent = null;
		private String virtualComponentName = null;

		public void setVirtualComponentName(String virtualComponentName) {
			this.virtualComponentName = virtualComponentName;
		}

		private TalendException(Exception e, String errorComponent, final java.util.Map<String, Object> globalMap) {
			this.currentComponent = errorComponent;
			this.globalMap = globalMap;
			this.e = e;
		}

		public Exception getException() {
			return this.e;
		}

		public String getCurrentComponent() {
			return this.currentComponent;
		}

		public String getExceptionCauseMessage(Exception e) {
			Throwable cause = e;
			String message = null;
			int i = 10;
			while (null != cause && 0 < i--) {
				message = cause.getMessage();
				if (null == message) {
					cause = cause.getCause();
				} else {
					break;
				}
			}
			if (null == message) {
				message = e.getClass().getName();
			}
			return message;
		}

		@Override
		public void printStackTrace() {
			if (!(e instanceof TalendException || e instanceof TDieException)) {
				if (virtualComponentName != null && currentComponent.indexOf(virtualComponentName + "_") == 0) {
					globalMap.put(virtualComponentName + "_ERROR_MESSAGE", getExceptionCauseMessage(e));
				}
				globalMap.put(currentComponent + "_ERROR_MESSAGE", getExceptionCauseMessage(e));
				System.err.println("Exception in component " + currentComponent + " (" + jobName + ")");
			}
			if (!(e instanceof TDieException)) {
				if (e instanceof TalendException) {
					e.printStackTrace();
				} else {
					e.printStackTrace();
					e.printStackTrace(errorMessagePS);
					accident_fact.this.exception = e;
				}
			}
			if (!(e instanceof TalendException)) {
				try {
					for (java.lang.reflect.Method m : this.getClass().getEnclosingClass().getMethods()) {
						if (m.getName().compareTo(currentComponent + "_error") == 0) {
							m.invoke(accident_fact.this, new Object[] { e, currentComponent, globalMap });
							break;
						}
					}

					if (!(e instanceof TDieException)) {
					}
				} catch (Exception e) {
					this.e.printStackTrace();
				}
			}
		}
	}

	public void tFileList_1_error(Exception exception, String errorComponent,
			final java.util.Map<String, Object> globalMap) throws TalendException {

		end_Hash.put(errorComponent, System.currentTimeMillis());

		status = "failure";

		tFileList_1_onSubJobError(exception, errorComponent, globalMap);
	}

	public void tFileInputDelimited_1_error(Exception exception, String errorComponent,
			final java.util.Map<String, Object> globalMap) throws TalendException {

		end_Hash.put(errorComponent, System.currentTimeMillis());

		status = "failure";

		tFileList_1_onSubJobError(exception, errorComponent, globalMap);
	}

	public void tMap_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap)
			throws TalendException {

		end_Hash.put(errorComponent, System.currentTimeMillis());

		status = "failure";

		tFileList_1_onSubJobError(exception, errorComponent, globalMap);
	}

	public void tDBOutput_2_error(Exception exception, String errorComponent,
			final java.util.Map<String, Object> globalMap) throws TalendException {

		end_Hash.put(errorComponent, System.currentTimeMillis());

		status = "failure";

		tFileList_1_onSubJobError(exception, errorComponent, globalMap);
	}

	public void tLogRow_1_error(Exception exception, String errorComponent,
			final java.util.Map<String, Object> globalMap) throws TalendException {

		end_Hash.put(errorComponent, System.currentTimeMillis());

		status = "failure";

		tFileList_1_onSubJobError(exception, errorComponent, globalMap);
	}

	public void tAggregateRow_1_AGGOUT_error(Exception exception, String errorComponent,
			final java.util.Map<String, Object> globalMap) throws TalendException {

		tAggregateRow_1_AGGIN_error(exception, errorComponent, globalMap);

	}

	public void tAggregateRow_1_AGGIN_error(Exception exception, String errorComponent,
			final java.util.Map<String, Object> globalMap) throws TalendException {

		end_Hash.put(errorComponent, System.currentTimeMillis());

		status = "failure";

		tFileList_1_onSubJobError(exception, errorComponent, globalMap);
	}

	public void tFileList_1_onSubJobError(Exception exception, String errorComponent,
			final java.util.Map<String, Object> globalMap) throws TalendException {

		resumeUtil.addLog("SYSTEM_LOG", "NODE:" + errorComponent, "", Thread.currentThread().getId() + "", "FATAL", "",
				exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception), "");

	}

	public static class out1Struct implements routines.system.IPersistableRow<out1Struct> {
		final static byte[] commonByteArrayLock_BI_accident_fact = new byte[0];
		static byte[] commonByteArray_BI_accident_fact = new byte[0];
		protected static final int DEFAULT_HASHCODE = 1;
		protected static final int PRIME = 31;
		protected int hashCode = DEFAULT_HASHCODE;
		public boolean hashCodeDirty = true;

		public String loopKey;

		public int id;

		public int getId() {
			return this.id;
		}

		public String lieuId;

		public String getLieuId() {
			return this.lieuId;
		}

		public String voieId;

		public String getVoieId() {
			return this.voieId;
		}

		public String dateId;

		public String getDateId() {
			return this.dateId;
		}

		public int meteoDim;

		public int getMeteoDim() {
			return this.meteoDim;
		}

		public int intersectionId;

		public int getIntersectionId() {
			return this.intersectionId;
		}

		public String surf;

		public String getSurf() {
			return this.surf;
		}

		public String situation;

		public String getSituation() {
			return this.situation;
		}

		public String luminosite;

		public String getLuminosite() {
			return this.luminosite;
		}

		public Integer heure;

		public Integer getHeure() {
			return this.heure;
		}

		public Integer nombre_morts;

		public Integer getNombre_morts() {
			return this.nombre_morts;
		}

		public Integer nombre_blesses;

		public Integer getNombre_blesses() {
			return this.nombre_blesses;
		}

		public Integer nombre_hospitalises;

		public Integer getNombre_hospitalises() {
			return this.nombre_hospitalises;
		}

		public Integer nombre_indemmes;

		public Integer getNombre_indemmes() {
			return this.nombre_indemmes;
		}

		public Integer pourcentage_homme;

		public Integer getPourcentage_homme() {
			return this.pourcentage_homme;
		}

		@Override
		public int hashCode() {
			if (this.hashCodeDirty) {
				final int prime = PRIME;
				int result = DEFAULT_HASHCODE;

				result = prime * result + (int) this.id;

				this.hashCode = result;
				this.hashCodeDirty = false;
			}
			return this.hashCode;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			final out1Struct other = (out1Struct) obj;

			if (this.id != other.id)
				return false;

			return true;
		}

		public void copyDataTo(out1Struct other) {

			other.id = this.id;
			other.lieuId = this.lieuId;
			other.voieId = this.voieId;
			other.dateId = this.dateId;
			other.meteoDim = this.meteoDim;
			other.intersectionId = this.intersectionId;
			other.surf = this.surf;
			other.situation = this.situation;
			other.luminosite = this.luminosite;
			other.heure = this.heure;
			other.nombre_morts = this.nombre_morts;
			other.nombre_blesses = this.nombre_blesses;
			other.nombre_hospitalises = this.nombre_hospitalises;
			other.nombre_indemmes = this.nombre_indemmes;
			other.pourcentage_homme = this.pourcentage_homme;

		}

		public void copyKeysDataTo(out1Struct other) {

			other.id = this.id;

		}

		private String readString(ObjectInputStream dis) throws IOException {
			String strReturn = null;
			int length = 0;
			length = dis.readInt();
			if (length == -1) {
				strReturn = null;
			} else {
				if (length > commonByteArray_BI_accident_fact.length) {
					if (length < 1024 && commonByteArray_BI_accident_fact.length == 0) {
						commonByteArray_BI_accident_fact = new byte[1024];
					} else {
						commonByteArray_BI_accident_fact = new byte[2 * length];
					}
				}
				dis.readFully(commonByteArray_BI_accident_fact, 0, length);
				strReturn = new String(commonByteArray_BI_accident_fact, 0, length, utf8Charset);
			}
			return strReturn;
		}

		private void writeString(String str, ObjectOutputStream dos) throws IOException {
			if (str == null) {
				dos.writeInt(-1);
			} else {
				byte[] byteArray = str.getBytes(utf8Charset);
				dos.writeInt(byteArray.length);
				dos.write(byteArray);
			}
		}

		private Integer readInteger(ObjectInputStream dis) throws IOException {
			Integer intReturn;
			int length = 0;
			length = dis.readByte();
			if (length == -1) {
				intReturn = null;
			} else {
				intReturn = dis.readInt();
			}
			return intReturn;
		}

		private void writeInteger(Integer intNum, ObjectOutputStream dos) throws IOException {
			if (intNum == null) {
				dos.writeByte(-1);
			} else {
				dos.writeByte(0);
				dos.writeInt(intNum);
			}
		}

		public void readData(ObjectInputStream dis) {

			synchronized (commonByteArrayLock_BI_accident_fact) {

				try {

					int length = 0;

					this.id = dis.readInt();

					this.lieuId = readString(dis);

					this.voieId = readString(dis);

					this.dateId = readString(dis);

					this.meteoDim = dis.readInt();

					this.intersectionId = dis.readInt();

					this.surf = readString(dis);

					this.situation = readString(dis);

					this.luminosite = readString(dis);

					this.heure = readInteger(dis);

					this.nombre_morts = readInteger(dis);

					this.nombre_blesses = readInteger(dis);

					this.nombre_hospitalises = readInteger(dis);

					this.nombre_indemmes = readInteger(dis);

					this.pourcentage_homme = readInteger(dis);

				} catch (IOException e) {
					throw new RuntimeException(e);

				}

			}

		}

		public void writeData(ObjectOutputStream dos) {
			try {

				// int

				dos.writeInt(this.id);

				// String

				writeString(this.lieuId, dos);

				// String

				writeString(this.voieId, dos);

				// String

				writeString(this.dateId, dos);

				// int

				dos.writeInt(this.meteoDim);

				// int

				dos.writeInt(this.intersectionId);

				// String

				writeString(this.surf, dos);

				// String

				writeString(this.situation, dos);

				// String

				writeString(this.luminosite, dos);

				// Integer

				writeInteger(this.heure, dos);

				// Integer

				writeInteger(this.nombre_morts, dos);

				// Integer

				writeInteger(this.nombre_blesses, dos);

				// Integer

				writeInteger(this.nombre_hospitalises, dos);

				// Integer

				writeInteger(this.nombre_indemmes, dos);

				// Integer

				writeInteger(this.pourcentage_homme, dos);

			} catch (IOException e) {
				throw new RuntimeException(e);
			}

		}

		public String toString() {

			StringBuilder sb = new StringBuilder();
			sb.append(super.toString());
			sb.append("[");
			sb.append("id=" + String.valueOf(id));
			sb.append(",lieuId=" + lieuId);
			sb.append(",voieId=" + voieId);
			sb.append(",dateId=" + dateId);
			sb.append(",meteoDim=" + String.valueOf(meteoDim));
			sb.append(",intersectionId=" + String.valueOf(intersectionId));
			sb.append(",surf=" + surf);
			sb.append(",situation=" + situation);
			sb.append(",luminosite=" + luminosite);
			sb.append(",heure=" + String.valueOf(heure));
			sb.append(",nombre_morts=" + String.valueOf(nombre_morts));
			sb.append(",nombre_blesses=" + String.valueOf(nombre_blesses));
			sb.append(",nombre_hospitalises=" + String.valueOf(nombre_hospitalises));
			sb.append(",nombre_indemmes=" + String.valueOf(nombre_indemmes));
			sb.append(",pourcentage_homme=" + String.valueOf(pourcentage_homme));
			sb.append("]");

			return sb.toString();
		}

		/**
		 * Compare keys
		 */
		public int compareTo(out1Struct other) {

			int returnValue = -1;

			returnValue = checkNullsAndCompare(this.id, other.id);
			if (returnValue != 0) {
				return returnValue;
			}

			return returnValue;
		}

		private int checkNullsAndCompare(Object object1, Object object2) {
			int returnValue = 0;
			if (object1 instanceof Comparable && object2 instanceof Comparable) {
				returnValue = ((Comparable) object1).compareTo(object2);
			} else if (object1 != null && object2 != null) {
				returnValue = compareStrings(object1.toString(), object2.toString());
			} else if (object1 == null && object2 != null) {
				returnValue = 1;
			} else if (object1 != null && object2 == null) {
				returnValue = -1;
			} else {
				returnValue = 0;
			}

			return returnValue;
		}

		private int compareStrings(String string1, String string2) {
			return string1.compareTo(string2);
		}

	}

	public static class row3Struct implements routines.system.IPersistableRow<row3Struct> {
		final static byte[] commonByteArrayLock_BI_accident_fact = new byte[0];
		static byte[] commonByteArray_BI_accident_fact = new byte[0];

		public int num_acc;

		public int getNum_acc() {
			return this.num_acc;
		}

		public void readData(ObjectInputStream dis) {

			synchronized (commonByteArrayLock_BI_accident_fact) {

				try {

					int length = 0;

					this.num_acc = dis.readInt();

				} catch (IOException e) {
					throw new RuntimeException(e);

				}

			}

		}

		public void writeData(ObjectOutputStream dos) {
			try {

				// int

				dos.writeInt(this.num_acc);

			} catch (IOException e) {
				throw new RuntimeException(e);
			}

		}

		public String toString() {

			StringBuilder sb = new StringBuilder();
			sb.append(super.toString());
			sb.append("[");
			sb.append("num_acc=" + String.valueOf(num_acc));
			sb.append("]");

			return sb.toString();
		}

		/**
		 * Compare keys
		 */
		public int compareTo(row3Struct other) {

			int returnValue = -1;

			return returnValue;
		}

		private int checkNullsAndCompare(Object object1, Object object2) {
			int returnValue = 0;
			if (object1 instanceof Comparable && object2 instanceof Comparable) {
				returnValue = ((Comparable) object1).compareTo(object2);
			} else if (object1 != null && object2 != null) {
				returnValue = compareStrings(object1.toString(), object2.toString());
			} else if (object1 == null && object2 != null) {
				returnValue = 1;
			} else if (object1 != null && object2 == null) {
				returnValue = -1;
			} else {
				returnValue = 0;
			}

			return returnValue;
		}

		private int compareStrings(String string1, String string2) {
			return string1.compareTo(string2);
		}

	}

	public static class OnRowsEndStructtAggregateRow_1
			implements routines.system.IPersistableRow<OnRowsEndStructtAggregateRow_1> {
		final static byte[] commonByteArrayLock_BI_accident_fact = new byte[0];
		static byte[] commonByteArray_BI_accident_fact = new byte[0];

		public int num_acc;

		public int getNum_acc() {
			return this.num_acc;
		}

		public void readData(ObjectInputStream dis) {

			synchronized (commonByteArrayLock_BI_accident_fact) {

				try {

					int length = 0;

					this.num_acc = dis.readInt();

				} catch (IOException e) {
					throw new RuntimeException(e);

				}

			}

		}

		public void writeData(ObjectOutputStream dos) {
			try {

				// int

				dos.writeInt(this.num_acc);

			} catch (IOException e) {
				throw new RuntimeException(e);
			}

		}

		public String toString() {

			StringBuilder sb = new StringBuilder();
			sb.append(super.toString());
			sb.append("[");
			sb.append("num_acc=" + String.valueOf(num_acc));
			sb.append("]");

			return sb.toString();
		}

		/**
		 * Compare keys
		 */
		public int compareTo(OnRowsEndStructtAggregateRow_1 other) {

			int returnValue = -1;

			return returnValue;
		}

		private int checkNullsAndCompare(Object object1, Object object2) {
			int returnValue = 0;
			if (object1 instanceof Comparable && object2 instanceof Comparable) {
				returnValue = ((Comparable) object1).compareTo(object2);
			} else if (object1 != null && object2 != null) {
				returnValue = compareStrings(object1.toString(), object2.toString());
			} else if (object1 == null && object2 != null) {
				returnValue = 1;
			} else if (object1 != null && object2 == null) {
				returnValue = -1;
			} else {
				returnValue = 0;
			}

			return returnValue;
		}

		private int compareStrings(String string1, String string2) {
			return string1.compareTo(string2);
		}

	}

	public static class row1Struct implements routines.system.IPersistableRow<row1Struct> {
		final static byte[] commonByteArrayLock_BI_accident_fact = new byte[0];
		static byte[] commonByteArray_BI_accident_fact = new byte[0];

		public int num_acc;

		public int getNum_acc() {
			return this.num_acc;
		}

		public void readData(ObjectInputStream dis) {

			synchronized (commonByteArrayLock_BI_accident_fact) {

				try {

					int length = 0;

					this.num_acc = dis.readInt();

				} catch (IOException e) {
					throw new RuntimeException(e);

				}

			}

		}

		public void writeData(ObjectOutputStream dos) {
			try {

				// int

				dos.writeInt(this.num_acc);

			} catch (IOException e) {
				throw new RuntimeException(e);
			}

		}

		public String toString() {

			StringBuilder sb = new StringBuilder();
			sb.append(super.toString());
			sb.append("[");
			sb.append("num_acc=" + String.valueOf(num_acc));
			sb.append("]");

			return sb.toString();
		}

		/**
		 * Compare keys
		 */
		public int compareTo(row1Struct other) {

			int returnValue = -1;

			return returnValue;
		}

		private int checkNullsAndCompare(Object object1, Object object2) {
			int returnValue = 0;
			if (object1 instanceof Comparable && object2 instanceof Comparable) {
				returnValue = ((Comparable) object1).compareTo(object2);
			} else if (object1 != null && object2 != null) {
				returnValue = compareStrings(object1.toString(), object2.toString());
			} else if (object1 == null && object2 != null) {
				returnValue = 1;
			} else if (object1 != null && object2 == null) {
				returnValue = -1;
			} else {
				returnValue = 0;
			}

			return returnValue;
		}

		private int compareStrings(String string1, String string2) {
			return string1.compareTo(string2);
		}

	}

	public static class row2Struct implements routines.system.IPersistableRow<row2Struct> {
		final static byte[] commonByteArrayLock_BI_accident_fact = new byte[0];
		static byte[] commonByteArray_BI_accident_fact = new byte[0];

		public int num_acc;

		public int getNum_acc() {
			return this.num_acc;
		}

		public String errorCode;

		public String getErrorCode() {
			return this.errorCode;
		}

		public String errorMessage;

		public String getErrorMessage() {
			return this.errorMessage;
		}

		private String readString(ObjectInputStream dis) throws IOException {
			String strReturn = null;
			int length = 0;
			length = dis.readInt();
			if (length == -1) {
				strReturn = null;
			} else {
				if (length > commonByteArray_BI_accident_fact.length) {
					if (length < 1024 && commonByteArray_BI_accident_fact.length == 0) {
						commonByteArray_BI_accident_fact = new byte[1024];
					} else {
						commonByteArray_BI_accident_fact = new byte[2 * length];
					}
				}
				dis.readFully(commonByteArray_BI_accident_fact, 0, length);
				strReturn = new String(commonByteArray_BI_accident_fact, 0, length, utf8Charset);
			}
			return strReturn;
		}

		private void writeString(String str, ObjectOutputStream dos) throws IOException {
			if (str == null) {
				dos.writeInt(-1);
			} else {
				byte[] byteArray = str.getBytes(utf8Charset);
				dos.writeInt(byteArray.length);
				dos.write(byteArray);
			}
		}

		public void readData(ObjectInputStream dis) {

			synchronized (commonByteArrayLock_BI_accident_fact) {

				try {

					int length = 0;

					this.num_acc = dis.readInt();

					this.errorCode = readString(dis);

					this.errorMessage = readString(dis);

				} catch (IOException e) {
					throw new RuntimeException(e);

				}

			}

		}

		public void writeData(ObjectOutputStream dos) {
			try {

				// int

				dos.writeInt(this.num_acc);

				// String

				writeString(this.errorCode, dos);

				// String

				writeString(this.errorMessage, dos);

			} catch (IOException e) {
				throw new RuntimeException(e);
			}

		}

		public String toString() {

			StringBuilder sb = new StringBuilder();
			sb.append(super.toString());
			sb.append("[");
			sb.append("num_acc=" + String.valueOf(num_acc));
			sb.append(",errorCode=" + errorCode);
			sb.append(",errorMessage=" + errorMessage);
			sb.append("]");

			return sb.toString();
		}

		/**
		 * Compare keys
		 */
		public int compareTo(row2Struct other) {

			int returnValue = -1;

			return returnValue;
		}

		private int checkNullsAndCompare(Object object1, Object object2) {
			int returnValue = 0;
			if (object1 instanceof Comparable && object2 instanceof Comparable) {
				returnValue = ((Comparable) object1).compareTo(object2);
			} else if (object1 != null && object2 != null) {
				returnValue = compareStrings(object1.toString(), object2.toString());
			} else if (object1 == null && object2 != null) {
				returnValue = 1;
			} else if (object1 != null && object2 == null) {
				returnValue = -1;
			} else {
				returnValue = 0;
			}

			return returnValue;
		}

		private int compareStrings(String string1, String string2) {
			return string1.compareTo(string2);
		}

	}

	public void tFileList_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
		globalMap.put("tFileList_1_SUBPROCESS_STATE", 0);

		final boolean execStat = this.execStat;
		String currentVirtualComponent = null;

		String iterateId = "";

		String currentComponent = "";
		java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

		try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { // start the resume
				globalResumeTicket = true;

				row1Struct row1 = new row1Struct();
				out1Struct out1 = new out1Struct();
				row2Struct row2 = new row2Struct();
				row3Struct row3 = new row3Struct();

				/**
				 * [tFileList_1 begin ] start
				 */

				int NB_ITERATE_tFileInputDelimited_1 = 0; // for statistics

				ok_Hash.put("tFileList_1", false);
				start_Hash.put("tFileList_1", System.currentTimeMillis());

				currentComponent = "tFileList_1";

				int tos_count_tFileList_1 = 0;

				String directory_tFileList_1 = "C:/Users/Felix/Desktop/Bi/securite-routiere/data";
				final java.util.List<String> maskList_tFileList_1 = new java.util.ArrayList<String>();
				final java.util.List<java.util.regex.Pattern> patternList_tFileList_1 = new java.util.ArrayList<java.util.regex.Pattern>();
				maskList_tFileList_1.add("usagers*");
				for (final String filemask_tFileList_1 : maskList_tFileList_1) {
					String filemask_compile_tFileList_1 = filemask_tFileList_1;

					filemask_compile_tFileList_1 = org.apache.oro.text.GlobCompiler.globToPerl5(
							filemask_tFileList_1.toCharArray(), org.apache.oro.text.GlobCompiler.DEFAULT_MASK);

					java.util.regex.Pattern fileNamePattern_tFileList_1 = java.util.regex.Pattern
							.compile(filemask_compile_tFileList_1);
					patternList_tFileList_1.add(fileNamePattern_tFileList_1);
				}
				int NB_FILEtFileList_1 = 0;

				final boolean case_sensitive_tFileList_1 = true;
				final java.util.List<java.io.File> list_tFileList_1 = new java.util.ArrayList<java.io.File>();
				final java.util.Set<String> filePath_tFileList_1 = new java.util.HashSet<String>();
				java.io.File file_tFileList_1 = new java.io.File(directory_tFileList_1);

				file_tFileList_1.listFiles(new java.io.FilenameFilter() {
					public boolean accept(java.io.File dir, String name) {
						java.io.File file = new java.io.File(dir, name);
						if (!file.isDirectory()) {

							String fileName_tFileList_1 = file.getName();
							for (final java.util.regex.Pattern fileNamePattern_tFileList_1 : patternList_tFileList_1) {
								if (fileNamePattern_tFileList_1.matcher(fileName_tFileList_1).matches()) {
									if (!filePath_tFileList_1.contains(file.getAbsolutePath())) {
										list_tFileList_1.add(file);
										filePath_tFileList_1.add(file.getAbsolutePath());
									}
								}
							}
						}
						return true;
					}
				});
				Comparator<java.io.File> fileNameASC_tFileList_1 = new Comparator<java.io.File>() {

					public int compare(java.io.File o1, java.io.File o2) {
						boolean bO1IsFile = o1.isFile();
						boolean bO2IsFile = o2.isFile();

						if (bO1IsFile && bO2IsFile) {
							return (o1.getName()).compareTo(o2.getName());
						} else if (bO1IsFile && (!bO2IsFile)) {
							return 1;
						} else if ((!bO1IsFile) && bO2IsFile) {
							return -1;
						} else if (!bO1IsFile && !bO2IsFile) {
							return (o1.getName()).compareTo(o2.getName());
						} else {
							return 0;
						}
					}
				};
				java.util.Collections.sort(list_tFileList_1, fileNameASC_tFileList_1);

				for (int i_tFileList_1 = 0; i_tFileList_1 < list_tFileList_1.size(); i_tFileList_1++) {
					java.io.File files_tFileList_1 = list_tFileList_1.get(i_tFileList_1);
					String fileName_tFileList_1 = files_tFileList_1.getName();

					String currentFileName_tFileList_1 = files_tFileList_1.getName();
					String currentFilePath_tFileList_1 = files_tFileList_1.getAbsolutePath();
					String currentFileDirectory_tFileList_1 = files_tFileList_1.getParent();
					String currentFileExtension_tFileList_1 = null;

					if (files_tFileList_1.getName().contains(".") && files_tFileList_1.isFile()) {
						currentFileExtension_tFileList_1 = files_tFileList_1.getName()
								.substring(files_tFileList_1.getName().lastIndexOf(".") + 1);
					} else {
						currentFileExtension_tFileList_1 = "";
					}
					currentFilePath_tFileList_1 = currentFilePath_tFileList_1.replaceAll("\\\\", "/");
					currentFileDirectory_tFileList_1 = currentFileDirectory_tFileList_1.replaceAll("\\\\", "/");

					NB_FILEtFileList_1++;
					globalMap.put("tFileList_1_CURRENT_FILE", currentFileName_tFileList_1);
					globalMap.put("tFileList_1_CURRENT_FILEPATH", currentFilePath_tFileList_1);
					globalMap.put("tFileList_1_CURRENT_FILEDIRECTORY", currentFileDirectory_tFileList_1);
					globalMap.put("tFileList_1_CURRENT_FILEEXTENSION", currentFileExtension_tFileList_1);
					globalMap.put("tFileList_1_NB_FILE", NB_FILEtFileList_1);

					/**
					 * [tFileList_1 begin ] stop
					 */

					/**
					 * [tFileList_1 main ] start
					 */

					currentComponent = "tFileList_1";

					tos_count_tFileList_1++;

					/**
					 * [tFileList_1 main ] stop
					 */

					/**
					 * [tFileList_1 process_data_begin ] start
					 */

					currentComponent = "tFileList_1";

					/**
					 * [tFileList_1 process_data_begin ] stop
					 */
					NB_ITERATE_tFileInputDelimited_1++;

					if (execStat) {
						runStat.updateStatOnConnection("row2", 3, 0);
					}

					if (execStat) {
						runStat.updateStatOnConnection("out1", 3, 0);
					}

					if (execStat) {
						runStat.updateStatOnConnection("row1", 3, 0);
					}

					if (execStat) {
						runStat.updateStatOnConnection("row3", 3, 0);
					}

					if (execStat) {
						runStat.updateStatOnConnection("OnRowsEnd", 3, 0);
					}

					if (execStat) {
						runStat.updateStatOnConnection("iterate1", 1, "exec" + NB_ITERATE_tFileInputDelimited_1);
						// Thread.sleep(1000);
					}

					/**
					 * [tDBOutput_2 begin ] start
					 */

					ok_Hash.put("tDBOutput_2", false);
					start_Hash.put("tDBOutput_2", System.currentTimeMillis());

					currentComponent = "tDBOutput_2";

					if (execStat) {
						runStat.updateStatOnConnection(resourceMap, iterateId, 0, 0, "out1");
					}

					int tos_count_tDBOutput_2 = 0;

					int nb_line_tDBOutput_2 = 0;
					int nb_line_update_tDBOutput_2 = 0;
					int nb_line_inserted_tDBOutput_2 = 0;
					int nb_line_deleted_tDBOutput_2 = 0;
					int nb_line_rejected_tDBOutput_2 = 0;

					int deletedCount_tDBOutput_2 = 0;
					int updatedCount_tDBOutput_2 = 0;
					int insertedCount_tDBOutput_2 = 0;

					int rejectedCount_tDBOutput_2 = 0;

					String tableName_tDBOutput_2 = "accident_fact";
					boolean whetherReject_tDBOutput_2 = false;

					java.util.Calendar calendar_tDBOutput_2 = java.util.Calendar.getInstance();
					calendar_tDBOutput_2.set(1, 0, 1, 0, 0, 0);
					long year1_tDBOutput_2 = calendar_tDBOutput_2.getTime().getTime();
					calendar_tDBOutput_2.set(10000, 0, 1, 0, 0, 0);
					long year10000_tDBOutput_2 = calendar_tDBOutput_2.getTime().getTime();
					long date_tDBOutput_2;

					java.sql.Connection conn_tDBOutput_2 = null;
					String dbProperties_tDBOutput_2 = "noDatetimeStringSync=true";
					String url_tDBOutput_2 = null;
					if (dbProperties_tDBOutput_2 == null || dbProperties_tDBOutput_2.trim().length() == 0) {
						url_tDBOutput_2 = "jdbc:mariadb://" + "localhost" + ":" + "3306" + "/" + "securite_routiere"
								+ "?" + "rewriteBatchedStatements=true";
					} else {
						String properties_tDBOutput_2 = "noDatetimeStringSync=true";
						if (!properties_tDBOutput_2.contains("rewriteBatchedStatements")) {
							properties_tDBOutput_2 += "&rewriteBatchedStatements=true";
						}

						url_tDBOutput_2 = "jdbc:mariadb://" + "localhost" + ":" + "3306" + "/" + "securite_routiere"
								+ "?" + properties_tDBOutput_2;
					}
					String driverClass_tDBOutput_2 = "org.mariadb.jdbc.Driver";

					String dbUser_tDBOutput_2 = "secu_user";

					final String decryptedPassword_tDBOutput_2 = routines.system.PasswordEncryptUtil.decryptPassword(
							"enc:routine.encryption.key.v1:QWsdDdpmyCoQgyq4KCjYGPsYL+2nMx2OHiVFuq1N2OFstyGw");

					String dbPwd_tDBOutput_2 = decryptedPassword_tDBOutput_2;
					java.lang.Class.forName(driverClass_tDBOutput_2);

					conn_tDBOutput_2 = java.sql.DriverManager.getConnection(url_tDBOutput_2, dbUser_tDBOutput_2,
							dbPwd_tDBOutput_2);

					resourceMap.put("conn_tDBOutput_2", conn_tDBOutput_2);
					conn_tDBOutput_2.setAutoCommit(false);
					int commitEvery_tDBOutput_2 = 10000;
					int commitCounter_tDBOutput_2 = 0;

					int count_tDBOutput_2 = 0;

					String insert_tDBOutput_2 = "INSERT INTO `" + "accident_fact"
							+ "` (`id`,`lieu_id`,`voie_id`,`date_id`,`meteo_dim`,`intersection_id`,`surf`,`situation`,`luminosite`,`heure`,`nombre_morts`,`nombre_blesses`,`nombre_hospitalises`,`nombre_indemmes`,`pourcentage_homme`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
					int batchSize_tDBOutput_2 = 100;
					int batchSizeCounter_tDBOutput_2 = 0;

					java.sql.PreparedStatement pstmt_tDBOutput_2 = conn_tDBOutput_2
							.prepareStatement(insert_tDBOutput_2);
					resourceMap.put("pstmt_tDBOutput_2", pstmt_tDBOutput_2);

					/**
					 * [tDBOutput_2 begin ] stop
					 */

					/**
					 * [tMap_1 begin ] start
					 */

					ok_Hash.put("tMap_1", false);
					start_Hash.put("tMap_1", System.currentTimeMillis());

					currentComponent = "tMap_1";

					if (execStat) {
						runStat.updateStatOnConnection(resourceMap, iterateId, 0, 0, "row1");
					}

					int tos_count_tMap_1 = 0;

// ###############################
// # Lookup's keys initialization
// ###############################        

// ###############################
// # Vars initialization
					class Var__tMap_1__Struct {
					}
					Var__tMap_1__Struct Var__tMap_1 = new Var__tMap_1__Struct();
// ###############################

// ###############################
// # Outputs initialization
					out1Struct out1_tmp = new out1Struct();
// ###############################

					/**
					 * [tMap_1 begin ] stop
					 */

					/**
					 * [tAggregateRow_1_AGGOUT begin ] start
					 */

					ok_Hash.put("tAggregateRow_1_AGGOUT", false);
					start_Hash.put("tAggregateRow_1_AGGOUT", System.currentTimeMillis());

					currentVirtualComponent = "tAggregateRow_1";

					currentComponent = "tAggregateRow_1_AGGOUT";

					if (execStat) {
						runStat.updateStatOnConnection(resourceMap, iterateId, 0, 0, "row2");
					}

					int tos_count_tAggregateRow_1_AGGOUT = 0;

// ------------ Seems it is not used

					java.util.Map hashAggreg_tAggregateRow_1 = new java.util.HashMap();

// ------------

					class UtilClass_tAggregateRow_1 { // G_OutBegin_AggR_144

						public double sd(Double[] data) {
							final int n = data.length;
							if (n < 2) {
								return Double.NaN;
							}
							double d1 = 0d;
							double d2 = 0d;

							for (int i = 0; i < data.length; i++) {
								d1 += (data[i] * data[i]);
								d2 += data[i];
							}

							return Math.sqrt((n * d1 - d2 * d2) / n / (n - 1));
						}

						public void checkedIADD(byte a, byte b, boolean checkTypeOverFlow, boolean checkUlp) {
							byte r = (byte) (a + b);
							if (checkTypeOverFlow && ((a ^ r) & (b ^ r)) < 0) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'short/Short'", "'byte/Byte'"));
							}
						}

						public void checkedIADD(short a, short b, boolean checkTypeOverFlow, boolean checkUlp) {
							short r = (short) (a + b);
							if (checkTypeOverFlow && ((a ^ r) & (b ^ r)) < 0) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'int/Integer'", "'short/Short'"));
							}
						}

						public void checkedIADD(int a, int b, boolean checkTypeOverFlow, boolean checkUlp) {
							int r = a + b;
							if (checkTypeOverFlow && ((a ^ r) & (b ^ r)) < 0) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'long/Long'", "'int/Integer'"));
							}
						}

						public void checkedIADD(long a, long b, boolean checkTypeOverFlow, boolean checkUlp) {
							long r = a + b;
							if (checkTypeOverFlow && ((a ^ r) & (b ^ r)) < 0) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'BigDecimal'", "'long/Long'"));
							}
						}

						public void checkedIADD(float a, float b, boolean checkTypeOverFlow, boolean checkUlp) {

							if (checkUlp) {
								float minAddedValue = Math.ulp(a);
								if (minAddedValue > Math.abs(b)) {
									throw new RuntimeException(buildPrecisionMessage(String.valueOf(a),
											String.valueOf(b), "'double' or 'BigDecimal'", "'float/Float'"));
								}
							}

							if (checkTypeOverFlow && ((double) a + (double) b > (double) Float.MAX_VALUE)
									|| ((double) a + (double) b < (double) -Float.MAX_VALUE)) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'double' or 'BigDecimal'", "'float/Float'"));
							}
						}

						public void checkedIADD(double a, double b, boolean checkTypeOverFlow, boolean checkUlp) {

							if (checkUlp) {
								double minAddedValue = Math.ulp(a);
								if (minAddedValue > Math.abs(b)) {
									throw new RuntimeException(buildPrecisionMessage(String.valueOf(a),
											String.valueOf(a), "'BigDecimal'", "'double/Double'"));
								}
							}

							if (checkTypeOverFlow && (a + b > (double) Double.MAX_VALUE)
									|| (a + b < -Double.MAX_VALUE)) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'BigDecimal'", "'double/Double'"));
							}
						}

						public void checkedIADD(double a, byte b, boolean checkTypeOverFlow, boolean checkUlp) {

							if (checkTypeOverFlow && (a + b > (double) Double.MAX_VALUE)
									|| (a + b < -Double.MAX_VALUE)) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'BigDecimal'", "'double/Double'"));
							}
						}

						public void checkedIADD(double a, short b, boolean checkTypeOverFlow, boolean checkUlp) {

							if (checkTypeOverFlow && (a + b > (double) Double.MAX_VALUE)
									|| (a + b < -Double.MAX_VALUE)) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'BigDecimal'", "'double/Double'"));
							}
						}

						public void checkedIADD(double a, int b, boolean checkTypeOverFlow, boolean checkUlp) {

							if (checkTypeOverFlow && (a + b > (double) Double.MAX_VALUE)
									|| (a + b < -Double.MAX_VALUE)) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'BigDecimal'", "'double/Double'"));
							}
						}

						public void checkedIADD(double a, float b, boolean checkTypeOverFlow, boolean checkUlp) {

							if (checkUlp) {
								double minAddedValue = Math.ulp(a);
								if (minAddedValue > Math.abs(b)) {
									throw new RuntimeException(buildPrecisionMessage(String.valueOf(a),
											String.valueOf(a), "'BigDecimal'", "'double/Double'"));
								}
							}

							if (checkTypeOverFlow && (a + b > (double) Double.MAX_VALUE)
									|| (a + b < -Double.MAX_VALUE)) {
								throw new RuntimeException(buildOverflowMessage(String.valueOf(a), String.valueOf(b),
										"'BigDecimal'", "'double/Double'"));
							}
						}

						private String buildOverflowMessage(String a, String b, String advicedTypes,
								String originalType) {
							return "Type overflow when adding " + b + " to " + a
									+ ", to resolve this problem, increase the precision by using " + advicedTypes
									+ " type in place of " + originalType + ".";
						}

						private String buildPrecisionMessage(String a, String b, String advicedTypes,
								String originalType) {
							return "The double precision is unsufficient to add the value " + b + " to " + a
									+ ", to resolve this problem, increase the precision by using " + advicedTypes
									+ " type in place of " + originalType + ".";
						}

					} // G_OutBegin_AggR_144

					UtilClass_tAggregateRow_1 utilClass_tAggregateRow_1 = new UtilClass_tAggregateRow_1();

					class AggOperationStruct_tAggregateRow_1 { // G_OutBegin_AggR_100

						private static final int DEFAULT_HASHCODE = 1;
						private static final int PRIME = 31;
						private int hashCode = DEFAULT_HASHCODE;
						public boolean hashCodeDirty = true;
						int count = 0;
						int num_acc_clmCount = 0;

						@Override
						public int hashCode() {
							if (this.hashCodeDirty) {
								final int prime = PRIME;
								int result = DEFAULT_HASHCODE;

								this.hashCode = result;
								this.hashCodeDirty = false;
							}
							return this.hashCode;
						}

						@Override
						public boolean equals(Object obj) {
							if (this == obj)
								return true;
							if (obj == null)
								return false;
							if (getClass() != obj.getClass())
								return false;
							final AggOperationStruct_tAggregateRow_1 other = (AggOperationStruct_tAggregateRow_1) obj;

							return true;
						}

					} // G_OutBegin_AggR_100

					AggOperationStruct_tAggregateRow_1 operation_result_tAggregateRow_1 = null;
					AggOperationStruct_tAggregateRow_1 operation_finder_tAggregateRow_1 = new AggOperationStruct_tAggregateRow_1();
					java.util.Map<AggOperationStruct_tAggregateRow_1, AggOperationStruct_tAggregateRow_1> hash_tAggregateRow_1 = new java.util.HashMap<AggOperationStruct_tAggregateRow_1, AggOperationStruct_tAggregateRow_1>();

					/**
					 * [tAggregateRow_1_AGGOUT begin ] stop
					 */

					/**
					 * [tFileInputDelimited_1 begin ] start
					 */

					ok_Hash.put("tFileInputDelimited_1", false);
					start_Hash.put("tFileInputDelimited_1", System.currentTimeMillis());

					currentComponent = "tFileInputDelimited_1";

					int tos_count_tFileInputDelimited_1 = 0;

					final routines.system.RowState rowstate_tFileInputDelimited_1 = new routines.system.RowState();

					int nb_line_tFileInputDelimited_1 = 0;
					org.talend.fileprocess.FileInputDelimited fid_tFileInputDelimited_1 = null;
					int limit_tFileInputDelimited_1 = -1;
					try {

						Object filename_tFileInputDelimited_1 = ((String) globalMap
								.get("tFileList_1_CURRENT_FILEPATH"));
						if (filename_tFileInputDelimited_1 instanceof java.io.InputStream) {

							int footer_value_tFileInputDelimited_1 = 0, random_value_tFileInputDelimited_1 = -1;
							if (footer_value_tFileInputDelimited_1 > 0 || random_value_tFileInputDelimited_1 > 0) {
								throw new java.lang.Exception(
										"When the input source is a stream,footer and random shouldn't be bigger than 0.");
							}

						}
						try {
							fid_tFileInputDelimited_1 = new org.talend.fileprocess.FileInputDelimited(
									((String) globalMap.get("tFileList_1_CURRENT_FILEPATH")), "ISO-8859-15", ",", "\n",
									true, 1, 0, limit_tFileInputDelimited_1, -1, false);
						} catch (java.lang.Exception e) {

							System.err.println(e.getMessage());

						}

						while (fid_tFileInputDelimited_1 != null && fid_tFileInputDelimited_1.nextRecord()) {
							rowstate_tFileInputDelimited_1.reset();

							row1 = null;

							row2 = null;

							boolean whetherReject_tFileInputDelimited_1 = false;
							row1 = new row1Struct();
							try {

								int columnIndexWithD_tFileInputDelimited_1 = 0;

								String temp = "";

								columnIndexWithD_tFileInputDelimited_1 = 0;

								temp = fid_tFileInputDelimited_1.get(columnIndexWithD_tFileInputDelimited_1);
								if (temp.length() > 0) {

									try {

										row1.num_acc = ParserUtils.parseTo_int(temp);

									} catch (java.lang.Exception ex_tFileInputDelimited_1) {
										rowstate_tFileInputDelimited_1.setException(new RuntimeException(String.format(
												"Couldn't parse value for column '%s' in '%s', value is '%s'. Details: %s",
												"num_acc", "row1", temp, ex_tFileInputDelimited_1),
												ex_tFileInputDelimited_1));
									}

								} else {

									rowstate_tFileInputDelimited_1.setException(new RuntimeException(
											"Value is empty for column : 'num_acc' in 'row1' connection, value is invalid or this column should be nullable or have a default value."));

								}

								if (rowstate_tFileInputDelimited_1.getException() != null) {
									throw rowstate_tFileInputDelimited_1.getException();
								}

							} catch (java.lang.Exception e) {
								whetherReject_tFileInputDelimited_1 = true;

								row2 = new row2Struct();

								row2.num_acc = row1.num_acc;

								row2.errorMessage = e.getMessage() + " - Line: " + tos_count_tFileInputDelimited_1;
								row1 = null;

							}

							/**
							 * [tFileInputDelimited_1 begin ] stop
							 */

							/**
							 * [tFileInputDelimited_1 main ] start
							 */

							currentComponent = "tFileInputDelimited_1";

							tos_count_tFileInputDelimited_1++;

							/**
							 * [tFileInputDelimited_1 main ] stop
							 */

							/**
							 * [tFileInputDelimited_1 process_data_begin ] start
							 */

							currentComponent = "tFileInputDelimited_1";

							/**
							 * [tFileInputDelimited_1 process_data_begin ] stop
							 */
// Start of branch "row1"
							if (row1 != null) {

								/**
								 * [tMap_1 main ] start
								 */

								currentComponent = "tMap_1";

								if (execStat) {
									runStat.updateStatOnConnection(iterateId, 1, 1, "row1");
								}

								boolean hasCasePrimitiveKeyWithNull_tMap_1 = false;

								// ###############################
								// # Input tables (lookups)
								boolean rejectedInnerJoin_tMap_1 = false;
								boolean mainRowRejected_tMap_1 = false;

								// ###############################
								{ // start of Var scope

									// ###############################
									// # Vars tables

									Var__tMap_1__Struct Var = Var__tMap_1;// ###############################
									// ###############################
									// # Output tables

									out1 = null;

// # Output table : 'out1'
									out1_tmp.id = row1.Num_Acc;
									out1_tmp.lieuId = null;
									out1_tmp.voieId = null;
									out1_tmp.dateId = null;
									out1_tmp.meteoDim = 0;
									out1_tmp.intersectionId = 0;
									out1_tmp.surf = null;
									out1_tmp.situation = null;
									out1_tmp.luminosite = null;
									out1_tmp.heure = null;
									out1_tmp.nombre_morts = null;
									out1_tmp.nombre_blesses = null;
									out1_tmp.nombre_hospitalises = null;
									out1_tmp.nombre_indemmes = null;
									out1_tmp.pourcentage_homme = null;
									out1 = out1_tmp;
// ###############################

								} // end of Var scope

								rejectedInnerJoin_tMap_1 = false;

								tos_count_tMap_1++;

								/**
								 * [tMap_1 main ] stop
								 */

								/**
								 * [tMap_1 process_data_begin ] start
								 */

								currentComponent = "tMap_1";

								/**
								 * [tMap_1 process_data_begin ] stop
								 */
// Start of branch "out1"
								if (out1 != null) {

									/**
									 * [tDBOutput_2 main ] start
									 */

									currentComponent = "tDBOutput_2";

									if (execStat) {
										runStat.updateStatOnConnection(iterateId, 1, 1, "out1");
									}

									whetherReject_tDBOutput_2 = false;
									pstmt_tDBOutput_2.setInt(1, out1.id);

									if (out1.lieuId == null) {
										pstmt_tDBOutput_2.setNull(2, java.sql.Types.VARCHAR);
									} else {
										pstmt_tDBOutput_2.setString(2, out1.lieuId);
									}

									if (out1.voieId == null) {
										pstmt_tDBOutput_2.setNull(3, java.sql.Types.VARCHAR);
									} else {
										pstmt_tDBOutput_2.setString(3, out1.voieId);
									}

									if (out1.dateId == null) {
										pstmt_tDBOutput_2.setNull(4, java.sql.Types.VARCHAR);
									} else {
										pstmt_tDBOutput_2.setString(4, out1.dateId);
									}

									pstmt_tDBOutput_2.setInt(5, out1.meteoDim);

									pstmt_tDBOutput_2.setInt(6, out1.intersectionId);

									if (out1.surf == null) {
										pstmt_tDBOutput_2.setNull(7, java.sql.Types.VARCHAR);
									} else {
										pstmt_tDBOutput_2.setString(7, out1.surf);
									}

									if (out1.situation == null) {
										pstmt_tDBOutput_2.setNull(8, java.sql.Types.VARCHAR);
									} else {
										pstmt_tDBOutput_2.setString(8, out1.situation);
									}

									if (out1.luminosite == null) {
										pstmt_tDBOutput_2.setNull(9, java.sql.Types.VARCHAR);
									} else {
										pstmt_tDBOutput_2.setString(9, out1.luminosite);
									}

									if (out1.heure == null) {
										pstmt_tDBOutput_2.setNull(10, java.sql.Types.INTEGER);
									} else {
										pstmt_tDBOutput_2.setInt(10, out1.heure);
									}

									if (out1.nombre_morts == null) {
										pstmt_tDBOutput_2.setNull(11, java.sql.Types.INTEGER);
									} else {
										pstmt_tDBOutput_2.setInt(11, out1.nombre_morts);
									}

									if (out1.nombre_blesses == null) {
										pstmt_tDBOutput_2.setNull(12, java.sql.Types.INTEGER);
									} else {
										pstmt_tDBOutput_2.setInt(12, out1.nombre_blesses);
									}

									if (out1.nombre_hospitalises == null) {
										pstmt_tDBOutput_2.setNull(13, java.sql.Types.INTEGER);
									} else {
										pstmt_tDBOutput_2.setInt(13, out1.nombre_hospitalises);
									}

									if (out1.nombre_indemmes == null) {
										pstmt_tDBOutput_2.setNull(14, java.sql.Types.INTEGER);
									} else {
										pstmt_tDBOutput_2.setInt(14, out1.nombre_indemmes);
									}

									if (out1.pourcentage_homme == null) {
										pstmt_tDBOutput_2.setNull(15, java.sql.Types.INTEGER);
									} else {
										pstmt_tDBOutput_2.setInt(15, out1.pourcentage_homme);
									}

									pstmt_tDBOutput_2.addBatch();
									nb_line_tDBOutput_2++;

									batchSizeCounter_tDBOutput_2++;
									if (batchSize_tDBOutput_2 <= batchSizeCounter_tDBOutput_2) {
										try {
											int countSum_tDBOutput_2 = 0;
											for (int countEach_tDBOutput_2 : pstmt_tDBOutput_2.executeBatch()) {
												countSum_tDBOutput_2 += (countEach_tDBOutput_2 == java.sql.Statement.EXECUTE_FAILED
														? 0
														: 1);
											}
											insertedCount_tDBOutput_2 += countSum_tDBOutput_2;
										} catch (java.sql.BatchUpdateException e) {
											int countSum_tDBOutput_2 = 0;
											for (int countEach_tDBOutput_2 : e.getUpdateCounts()) {
												countSum_tDBOutput_2 += (countEach_tDBOutput_2 < 0 ? 0
														: countEach_tDBOutput_2);
											}
											insertedCount_tDBOutput_2 += countSum_tDBOutput_2;
											System.err.println(e.getMessage());
										}

										batchSizeCounter_tDBOutput_2 = 0;
									}
									commitCounter_tDBOutput_2++;

									if (commitEvery_tDBOutput_2 <= commitCounter_tDBOutput_2) {

										try {
											int countSum_tDBOutput_2 = 0;
											for (int countEach_tDBOutput_2 : pstmt_tDBOutput_2.executeBatch()) {
												countSum_tDBOutput_2 += (countEach_tDBOutput_2 < 0 ? 0 : 1);
											}
											insertedCount_tDBOutput_2 += countSum_tDBOutput_2;
										} catch (java.sql.BatchUpdateException e) {
											int countSum_tDBOutput_2 = 0;
											for (int countEach_tDBOutput_2 : e.getUpdateCounts()) {
												countSum_tDBOutput_2 += (countEach_tDBOutput_2 < 0 ? 0
														: countEach_tDBOutput_2);
											}
											insertedCount_tDBOutput_2 += countSum_tDBOutput_2;
											System.err.println(e.getMessage());

										}
										conn_tDBOutput_2.commit();
										commitCounter_tDBOutput_2 = 0;

									}

									tos_count_tDBOutput_2++;

									/**
									 * [tDBOutput_2 main ] stop
									 */

									/**
									 * [tDBOutput_2 process_data_begin ] start
									 */

									currentComponent = "tDBOutput_2";

									/**
									 * [tDBOutput_2 process_data_begin ] stop
									 */

									/**
									 * [tDBOutput_2 process_data_end ] start
									 */

									currentComponent = "tDBOutput_2";

									/**
									 * [tDBOutput_2 process_data_end ] stop
									 */

								} // End of branch "out1"

								/**
								 * [tMap_1 process_data_end ] start
								 */

								currentComponent = "tMap_1";

								/**
								 * [tMap_1 process_data_end ] stop
								 */

							} // End of branch "row1"

// Start of branch "row2"
							if (row2 != null) {

								/**
								 * [tAggregateRow_1_AGGOUT main ] start
								 */

								currentVirtualComponent = "tAggregateRow_1";

								currentComponent = "tAggregateRow_1_AGGOUT";

								if (execStat) {
									runStat.updateStatOnConnection(iterateId, 1, 1, "row2");
								}

								operation_finder_tAggregateRow_1.hashCodeDirty = true;

								operation_result_tAggregateRow_1 = hash_tAggregateRow_1
										.get(operation_finder_tAggregateRow_1);

								if (operation_result_tAggregateRow_1 == null) { // G_OutMain_AggR_001

									operation_result_tAggregateRow_1 = new AggOperationStruct_tAggregateRow_1();

									hash_tAggregateRow_1.put(operation_result_tAggregateRow_1,
											operation_result_tAggregateRow_1);

								} // G_OutMain_AggR_001

								operation_result_tAggregateRow_1.num_acc_clmCount++;
								operation_result_tAggregateRow_1.count++;

								tos_count_tAggregateRow_1_AGGOUT++;

								/**
								 * [tAggregateRow_1_AGGOUT main ] stop
								 */

								/**
								 * [tAggregateRow_1_AGGOUT process_data_begin ] start
								 */

								currentVirtualComponent = "tAggregateRow_1";

								currentComponent = "tAggregateRow_1_AGGOUT";

								/**
								 * [tAggregateRow_1_AGGOUT process_data_begin ] stop
								 */

								/**
								 * [tAggregateRow_1_AGGOUT process_data_end ] start
								 */

								currentVirtualComponent = "tAggregateRow_1";

								currentComponent = "tAggregateRow_1_AGGOUT";

								/**
								 * [tAggregateRow_1_AGGOUT process_data_end ] stop
								 */

							} // End of branch "row2"

							/**
							 * [tFileInputDelimited_1 process_data_end ] start
							 */

							currentComponent = "tFileInputDelimited_1";

							/**
							 * [tFileInputDelimited_1 process_data_end ] stop
							 */

							/**
							 * [tFileInputDelimited_1 end ] start
							 */

							currentComponent = "tFileInputDelimited_1";

						}
					} finally {
						if (!((Object) (((String) globalMap
								.get("tFileList_1_CURRENT_FILEPATH"))) instanceof java.io.InputStream)) {
							if (fid_tFileInputDelimited_1 != null) {
								fid_tFileInputDelimited_1.close();
							}
						}
						if (fid_tFileInputDelimited_1 != null) {
							globalMap.put("tFileInputDelimited_1_NB_LINE", fid_tFileInputDelimited_1.getRowNumber());

						}
					}

					ok_Hash.put("tFileInputDelimited_1", true);
					end_Hash.put("tFileInputDelimited_1", System.currentTimeMillis());

					/**
					 * [tFileInputDelimited_1 end ] stop
					 */

					/**
					 * [tMap_1 end ] start
					 */

					currentComponent = "tMap_1";

// ###############################
// # Lookup hashes releasing
// ###############################      

					if (execStat) {
						runStat.updateStat(resourceMap, iterateId, 2, 0, "row1");
					}

					ok_Hash.put("tMap_1", true);
					end_Hash.put("tMap_1", System.currentTimeMillis());

					/**
					 * [tMap_1 end ] stop
					 */

					/**
					 * [tDBOutput_2 end ] start
					 */

					currentComponent = "tDBOutput_2";

					try {
						if (batchSizeCounter_tDBOutput_2 != 0) {
							int countSum_tDBOutput_2 = 0;

							for (int countEach_tDBOutput_2 : pstmt_tDBOutput_2.executeBatch()) {
								countSum_tDBOutput_2 += (countEach_tDBOutput_2 == java.sql.Statement.EXECUTE_FAILED ? 0
										: 1);
							}

							insertedCount_tDBOutput_2 += countSum_tDBOutput_2;

						}

					} catch (java.sql.BatchUpdateException e) {

						int countSum_tDBOutput_2 = 0;
						for (int countEach_tDBOutput_2 : e.getUpdateCounts()) {
							countSum_tDBOutput_2 += (countEach_tDBOutput_2 < 0 ? 0 : countEach_tDBOutput_2);
						}

						insertedCount_tDBOutput_2 += countSum_tDBOutput_2;

						globalMap.put(currentComponent + "_ERROR_MESSAGE", e.getMessage());
						System.err.println(e.getMessage());

					}
					batchSizeCounter_tDBOutput_2 = 0;

					if (pstmt_tDBOutput_2 != null) {

						pstmt_tDBOutput_2.close();
						resourceMap.remove("pstmt_tDBOutput_2");

					}
					resourceMap.put("statementClosed_tDBOutput_2", true);
					if (commitCounter_tDBOutput_2 > 0) {

						conn_tDBOutput_2.commit();

					}

					conn_tDBOutput_2.close();

					resourceMap.put("finish_tDBOutput_2", true);

					nb_line_deleted_tDBOutput_2 = nb_line_deleted_tDBOutput_2 + deletedCount_tDBOutput_2;
					nb_line_update_tDBOutput_2 = nb_line_update_tDBOutput_2 + updatedCount_tDBOutput_2;
					nb_line_inserted_tDBOutput_2 = nb_line_inserted_tDBOutput_2 + insertedCount_tDBOutput_2;
					nb_line_rejected_tDBOutput_2 = nb_line_rejected_tDBOutput_2 + rejectedCount_tDBOutput_2;

					globalMap.put("tDBOutput_2_NB_LINE", nb_line_tDBOutput_2);
					globalMap.put("tDBOutput_2_NB_LINE_UPDATED", nb_line_update_tDBOutput_2);
					globalMap.put("tDBOutput_2_NB_LINE_INSERTED", nb_line_inserted_tDBOutput_2);
					globalMap.put("tDBOutput_2_NB_LINE_DELETED", nb_line_deleted_tDBOutput_2);
					globalMap.put("tDBOutput_2_NB_LINE_REJECTED", nb_line_rejected_tDBOutput_2);

					if (execStat) {
						runStat.updateStat(resourceMap, iterateId, 2, 0, "out1");
					}

					ok_Hash.put("tDBOutput_2", true);
					end_Hash.put("tDBOutput_2", System.currentTimeMillis());

					/**
					 * [tDBOutput_2 end ] stop
					 */

					/**
					 * [tAggregateRow_1_AGGOUT end ] start
					 */

					currentVirtualComponent = "tAggregateRow_1";

					currentComponent = "tAggregateRow_1_AGGOUT";

					if (execStat) {
						runStat.updateStat(resourceMap, iterateId, 2, 0, "row2");
					}

					ok_Hash.put("tAggregateRow_1_AGGOUT", true);
					end_Hash.put("tAggregateRow_1_AGGOUT", System.currentTimeMillis());

					/**
					 * [tAggregateRow_1_AGGOUT end ] stop
					 */

					/**
					 * [tLogRow_1 begin ] start
					 */

					ok_Hash.put("tLogRow_1", false);
					start_Hash.put("tLogRow_1", System.currentTimeMillis());

					currentComponent = "tLogRow_1";

					if (execStat) {
						runStat.updateStatOnConnection(resourceMap, iterateId, 0, 0, "row3");
					}

					int tos_count_tLogRow_1 = 0;

					///////////////////////

					final String OUTPUT_FIELD_SEPARATOR_tLogRow_1 = "|";
					java.io.PrintStream consoleOut_tLogRow_1 = null;

					StringBuilder strBuffer_tLogRow_1 = null;
					int nb_line_tLogRow_1 = 0;
///////////////////////    			

					/**
					 * [tLogRow_1 begin ] stop
					 */

					/**
					 * [tAggregateRow_1_AGGIN begin ] start
					 */

					ok_Hash.put("tAggregateRow_1_AGGIN", false);
					start_Hash.put("tAggregateRow_1_AGGIN", System.currentTimeMillis());

					currentVirtualComponent = "tAggregateRow_1";

					currentComponent = "tAggregateRow_1_AGGIN";

					int tos_count_tAggregateRow_1_AGGIN = 0;

					java.util.Collection<AggOperationStruct_tAggregateRow_1> values_tAggregateRow_1 = hash_tAggregateRow_1
							.values();

					globalMap.put("tAggregateRow_1_NB_LINE", values_tAggregateRow_1.size());

					for (AggOperationStruct_tAggregateRow_1 aggregated_row_tAggregateRow_1 : values_tAggregateRow_1) { // G_AggR_600

						/**
						 * [tAggregateRow_1_AGGIN begin ] stop
						 */

						/**
						 * [tAggregateRow_1_AGGIN main ] start
						 */

						currentVirtualComponent = "tAggregateRow_1";

						currentComponent = "tAggregateRow_1_AGGIN";

						row3.num_acc = (int) aggregated_row_tAggregateRow_1.count;
						row3.num_acc = (int) aggregated_row_tAggregateRow_1.num_acc_clmCount;

						tos_count_tAggregateRow_1_AGGIN++;

						/**
						 * [tAggregateRow_1_AGGIN main ] stop
						 */

						/**
						 * [tAggregateRow_1_AGGIN process_data_begin ] start
						 */

						currentVirtualComponent = "tAggregateRow_1";

						currentComponent = "tAggregateRow_1_AGGIN";

						/**
						 * [tAggregateRow_1_AGGIN process_data_begin ] stop
						 */

						/**
						 * [tLogRow_1 main ] start
						 */

						currentComponent = "tLogRow_1";

						if (execStat) {
							runStat.updateStatOnConnection(iterateId, 1, 1, "row3");
						}

///////////////////////		

						strBuffer_tLogRow_1 = new StringBuilder();

						strBuffer_tLogRow_1.append(String.valueOf(row3.num_acc));

						if (globalMap.get("tLogRow_CONSOLE") != null) {
							consoleOut_tLogRow_1 = (java.io.PrintStream) globalMap.get("tLogRow_CONSOLE");
						} else {
							consoleOut_tLogRow_1 = new java.io.PrintStream(
									new java.io.BufferedOutputStream(System.out));
							globalMap.put("tLogRow_CONSOLE", consoleOut_tLogRow_1);
						}
						consoleOut_tLogRow_1.println(strBuffer_tLogRow_1.toString());
						consoleOut_tLogRow_1.flush();
						nb_line_tLogRow_1++;
//////

//////                    

///////////////////////    			

						tos_count_tLogRow_1++;

						/**
						 * [tLogRow_1 main ] stop
						 */

						/**
						 * [tLogRow_1 process_data_begin ] start
						 */

						currentComponent = "tLogRow_1";

						/**
						 * [tLogRow_1 process_data_begin ] stop
						 */

						/**
						 * [tLogRow_1 process_data_end ] start
						 */

						currentComponent = "tLogRow_1";

						/**
						 * [tLogRow_1 process_data_end ] stop
						 */

						/**
						 * [tAggregateRow_1_AGGIN process_data_end ] start
						 */

						currentVirtualComponent = "tAggregateRow_1";

						currentComponent = "tAggregateRow_1_AGGIN";

						/**
						 * [tAggregateRow_1_AGGIN process_data_end ] stop
						 */

						/**
						 * [tAggregateRow_1_AGGIN end ] start
						 */

						currentVirtualComponent = "tAggregateRow_1";

						currentComponent = "tAggregateRow_1_AGGIN";

					} // G_AggR_600

					ok_Hash.put("tAggregateRow_1_AGGIN", true);
					end_Hash.put("tAggregateRow_1_AGGIN", System.currentTimeMillis());

					/**
					 * [tAggregateRow_1_AGGIN end ] stop
					 */

					/**
					 * [tLogRow_1 end ] start
					 */

					currentComponent = "tLogRow_1";

//////
//////
					globalMap.put("tLogRow_1_NB_LINE", nb_line_tLogRow_1);

///////////////////////    			

					if (execStat) {
						runStat.updateStat(resourceMap, iterateId, 2, 0, "row3");
					}

					ok_Hash.put("tLogRow_1", true);
					end_Hash.put("tLogRow_1", System.currentTimeMillis());

					/**
					 * [tLogRow_1 end ] stop
					 */

					if (execStat) {
						runStat.updateStatOnConnection("iterate1", 2, "exec" + NB_ITERATE_tFileInputDelimited_1);
					}

					/**
					 * [tFileList_1 process_data_end ] start
					 */

					currentComponent = "tFileList_1";

					/**
					 * [tFileList_1 process_data_end ] stop
					 */

					/**
					 * [tFileList_1 end ] start
					 */

					currentComponent = "tFileList_1";

				}
				globalMap.put("tFileList_1_NB_FILE", NB_FILEtFileList_1);

				if (NB_FILEtFileList_1 == 0)
					throw new RuntimeException("No file found in directory " + directory_tFileList_1);

				ok_Hash.put("tFileList_1", true);
				end_Hash.put("tFileList_1", System.currentTimeMillis());

				/**
				 * [tFileList_1 end ] stop
				 */
			} // end the resume

		} catch (java.lang.Exception e) {

			TalendException te = new TalendException(e, currentComponent, globalMap);

			te.setVirtualComponentName(currentVirtualComponent);

			throw te;
		} catch (java.lang.Error error) {

			runStat.stopThreadStat();

			throw error;
		} finally {

			// free memory for "tAggregateRow_1_AGGIN"
			globalMap.remove("tAggregateRow_1");

			try {

				/**
				 * [tFileList_1 finally ] start
				 */

				currentComponent = "tFileList_1";

				/**
				 * [tFileList_1 finally ] stop
				 */

				/**
				 * [tFileInputDelimited_1 finally ] start
				 */

				currentComponent = "tFileInputDelimited_1";

				/**
				 * [tFileInputDelimited_1 finally ] stop
				 */

				/**
				 * [tMap_1 finally ] start
				 */

				currentComponent = "tMap_1";

				/**
				 * [tMap_1 finally ] stop
				 */

				/**
				 * [tDBOutput_2 finally ] start
				 */

				currentComponent = "tDBOutput_2";

				try {
					if (resourceMap.get("statementClosed_tDBOutput_2") == null) {
						java.sql.PreparedStatement pstmtToClose_tDBOutput_2 = null;
						if ((pstmtToClose_tDBOutput_2 = (java.sql.PreparedStatement) resourceMap
								.remove("pstmt_tDBOutput_2")) != null) {
							pstmtToClose_tDBOutput_2.close();
						}
					}
				} finally {
					if (resourceMap.get("finish_tDBOutput_2") == null) {
						java.sql.Connection ctn_tDBOutput_2 = null;
						if ((ctn_tDBOutput_2 = (java.sql.Connection) resourceMap.get("conn_tDBOutput_2")) != null) {
							try {
								ctn_tDBOutput_2.close();
							} catch (java.sql.SQLException sqlEx_tDBOutput_2) {
								String errorMessage_tDBOutput_2 = "failed to close the connection in tDBOutput_2 :"
										+ sqlEx_tDBOutput_2.getMessage();
								System.err.println(errorMessage_tDBOutput_2);
							}
						}
					}
				}

				/**
				 * [tDBOutput_2 finally ] stop
				 */

				/**
				 * [tAggregateRow_1_AGGOUT finally ] start
				 */

				currentVirtualComponent = "tAggregateRow_1";

				currentComponent = "tAggregateRow_1_AGGOUT";

				/**
				 * [tAggregateRow_1_AGGOUT finally ] stop
				 */

				/**
				 * [tAggregateRow_1_AGGIN finally ] start
				 */

				currentVirtualComponent = "tAggregateRow_1";

				currentComponent = "tAggregateRow_1_AGGIN";

				/**
				 * [tAggregateRow_1_AGGIN finally ] stop
				 */

				/**
				 * [tLogRow_1 finally ] start
				 */

				currentComponent = "tLogRow_1";

				/**
				 * [tLogRow_1 finally ] stop
				 */

			} catch (java.lang.Exception e) {
				// ignore
			} catch (java.lang.Error error) {
				// ignore
			}
			resourceMap = null;
		}

		globalMap.put("tFileList_1_SUBPROCESS_STATE", 1);
	}

	public String resuming_logs_dir_path = null;
	public String resuming_checkpoint_path = null;
	public String parent_part_launcher = null;
	private String resumeEntryMethodName = null;
	private boolean globalResumeTicket = false;

	public boolean watch = false;
	// portStats is null, it means don't execute the statistics
	public Integer portStats = null;
	public int portTraces = 4334;
	public String clientHost;
	public String defaultClientHost = "localhost";
	public String contextStr = "Default";
	public boolean isDefaultContext = true;
	public String pid = "0";
	public String rootPid = null;
	public String fatherPid = null;
	public String fatherNode = null;
	public long startTime = 0;
	public boolean isChildJob = false;
	public String log4jLevel = "";

	private boolean enableLogStash;

	private boolean execStat = true;

	private ThreadLocal<java.util.Map<String, String>> threadLocal = new ThreadLocal<java.util.Map<String, String>>() {
		protected java.util.Map<String, String> initialValue() {
			java.util.Map<String, String> threadRunResultMap = new java.util.HashMap<String, String>();
			threadRunResultMap.put("errorCode", null);
			threadRunResultMap.put("status", "");
			return threadRunResultMap;
		};
	};

	private PropertiesWithType context_param = new PropertiesWithType();
	public java.util.Map<String, Object> parentContextMap = new java.util.HashMap<String, Object>();

	public String status = "";

	public static void main(String[] args) {
		final accident_fact accident_factClass = new accident_fact();

		int exitCode = accident_factClass.runJobInTOS(args);

		System.exit(exitCode);
	}

	public String[][] runJob(String[] args) {

		int exitCode = runJobInTOS(args);
		String[][] bufferValue = new String[][] { { Integer.toString(exitCode) } };

		return bufferValue;
	}

	public boolean hastBufferOutputComponent() {
		boolean hastBufferOutput = false;

		return hastBufferOutput;
	}

	public int runJobInTOS(String[] args) {
		// reset status
		status = "";

		String lastStr = "";
		for (String arg : args) {
			if (arg.equalsIgnoreCase("--context_param")) {
				lastStr = arg;
			} else if (lastStr.equals("")) {
				evalParam(arg);
			} else {
				evalParam(lastStr + " " + arg);
				lastStr = "";
			}
		}
		enableLogStash = "true".equalsIgnoreCase(System.getProperty("monitoring"));

		if (clientHost == null) {
			clientHost = defaultClientHost;
		}

		if (pid == null || "0".equals(pid)) {
			pid = TalendString.getAsciiRandomString(6);
		}

		if (rootPid == null) {
			rootPid = pid;
		}
		if (fatherPid == null) {
			fatherPid = pid;
		} else {
			isChildJob = true;
		}

		if (portStats != null) {
			// portStats = -1; //for testing
			if (portStats < 0 || portStats > 65535) {
				// issue:10869, the portStats is invalid, so this client socket can't open
				System.err.println("The statistics socket port " + portStats + " is invalid.");
				execStat = false;
			}
		} else {
			execStat = false;
		}

		try {
			// call job/subjob with an existing context, like: --context=production. if
			// without this parameter, there will use the default context instead.
			java.io.InputStream inContext = accident_fact.class.getClassLoader()
					.getResourceAsStream("bi/accident_fact_0_1/contexts/" + contextStr + ".properties");
			if (inContext == null) {
				inContext = accident_fact.class.getClassLoader()
						.getResourceAsStream("config/contexts/" + contextStr + ".properties");
			}
			if (inContext != null) {
				// defaultProps is in order to keep the original context value
				if (context != null && context.isEmpty()) {
					defaultProps.load(inContext);
					context = new ContextProperties(defaultProps);
				}

				inContext.close();
			} else if (!isDefaultContext) {
				// print info and job continue to run, for case: context_param is not empty.
				System.err.println("Could not find the context " + contextStr);
			}

			if (!context_param.isEmpty()) {
				context.putAll(context_param);
				// set types for params from parentJobs
				for (Object key : context_param.keySet()) {
					String context_key = key.toString();
					String context_type = context_param.getContextType(context_key);
					context.setContextType(context_key, context_type);

				}
			}
			class ContextProcessing {
				private void processContext_0() {
				}

				public void processAllContext() {
					processContext_0();
				}
			}

			new ContextProcessing().processAllContext();
		} catch (java.io.IOException ie) {
			System.err.println("Could not load context " + contextStr);
			ie.printStackTrace();
		}

		// get context value from parent directly
		if (parentContextMap != null && !parentContextMap.isEmpty()) {
		}

		// Resume: init the resumeUtil
		resumeEntryMethodName = ResumeUtil.getResumeEntryMethodName(resuming_checkpoint_path);
		resumeUtil = new ResumeUtil(resuming_logs_dir_path, isChildJob, rootPid);
		resumeUtil.initCommonInfo(pid, rootPid, fatherPid, projectName, jobName, contextStr, jobVersion);

		List<String> parametersToEncrypt = new java.util.ArrayList<String>();
		// Resume: jobStart
		resumeUtil.addLog("JOB_STARTED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "",
				"", "", "", "", resumeUtil.convertToJsonText(context, parametersToEncrypt));

		if (execStat) {
			try {
				runStat.openSocket(!isChildJob);
				runStat.setAllPID(rootPid, fatherPid, pid, jobName);
				runStat.startThreadStat(clientHost, portStats);
				runStat.updateStatOnJob(RunStat.JOBSTART, fatherNode);
			} catch (java.io.IOException ioException) {
				ioException.printStackTrace();
			}
		}

		java.util.concurrent.ConcurrentHashMap<Object, Object> concurrentHashMap = new java.util.concurrent.ConcurrentHashMap<Object, Object>();
		globalMap.put("concurrentHashMap", concurrentHashMap);

		long startUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
		long endUsedMemory = 0;
		long end = 0;

		startTime = System.currentTimeMillis();

		this.globalResumeTicket = true;// to run tPreJob

		this.globalResumeTicket = false;// to run others jobs

		try {
			errorCode = null;
			tFileList_1Process(globalMap);
			if (!"failure".equals(status)) {
				status = "end";
			}
		} catch (TalendException e_tFileList_1) {
			globalMap.put("tFileList_1_SUBPROCESS_STATE", -1);

			e_tFileList_1.printStackTrace();

		}

		this.globalResumeTicket = true;// to run tPostJob

		end = System.currentTimeMillis();

		if (watch) {
			System.out.println((end - startTime) + " milliseconds");
		}

		endUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
		if (false) {
			System.out
					.println((endUsedMemory - startUsedMemory) + " bytes memory increase when running : accident_fact");
		}

		if (execStat) {
			runStat.updateStatOnJob(RunStat.JOBEND, fatherNode);
			runStat.stopThreadStat();
		}
		int returnCode = 0;
		if (errorCode == null) {
			returnCode = status != null && status.equals("failure") ? 1 : 0;
		} else {
			returnCode = errorCode.intValue();
		}
		resumeUtil.addLog("JOB_ENDED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "",
				"" + returnCode, "", "", "");

		return returnCode;

	}

	// only for OSGi env
	public void destroy() {

	}

	private java.util.Map<String, Object> getSharedConnections4REST() {
		java.util.Map<String, Object> connections = new java.util.HashMap<String, Object>();

		return connections;
	}

	private void evalParam(String arg) {
		if (arg.startsWith("--resuming_logs_dir_path")) {
			resuming_logs_dir_path = arg.substring(25);
		} else if (arg.startsWith("--resuming_checkpoint_path")) {
			resuming_checkpoint_path = arg.substring(27);
		} else if (arg.startsWith("--parent_part_launcher")) {
			parent_part_launcher = arg.substring(23);
		} else if (arg.startsWith("--watch")) {
			watch = true;
		} else if (arg.startsWith("--stat_port=")) {
			String portStatsStr = arg.substring(12);
			if (portStatsStr != null && !portStatsStr.equals("null")) {
				portStats = Integer.parseInt(portStatsStr);
			}
		} else if (arg.startsWith("--trace_port=")) {
			portTraces = Integer.parseInt(arg.substring(13));
		} else if (arg.startsWith("--client_host=")) {
			clientHost = arg.substring(14);
		} else if (arg.startsWith("--context=")) {
			contextStr = arg.substring(10);
			isDefaultContext = false;
		} else if (arg.startsWith("--father_pid=")) {
			fatherPid = arg.substring(13);
		} else if (arg.startsWith("--root_pid=")) {
			rootPid = arg.substring(11);
		} else if (arg.startsWith("--father_node=")) {
			fatherNode = arg.substring(14);
		} else if (arg.startsWith("--pid=")) {
			pid = arg.substring(6);
		} else if (arg.startsWith("--context_type")) {
			String keyValue = arg.substring(15);
			int index = -1;
			if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
				if (fatherPid == null) {
					context_param.setContextType(keyValue.substring(0, index),
							replaceEscapeChars(keyValue.substring(index + 1)));
				} else { // the subjob won't escape the especial chars
					context_param.setContextType(keyValue.substring(0, index), keyValue.substring(index + 1));
				}

			}

		} else if (arg.startsWith("--context_param")) {
			String keyValue = arg.substring(16);
			int index = -1;
			if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
				if (fatherPid == null) {
					context_param.put(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
				} else { // the subjob won't escape the especial chars
					context_param.put(keyValue.substring(0, index), keyValue.substring(index + 1));
				}
			}
		} else if (arg.startsWith("--log4jLevel=")) {
			log4jLevel = arg.substring(13);
		} else if (arg.startsWith("--monitoring") && arg.contains("=")) {// for trunjob call
			final int equal = arg.indexOf('=');
			final String key = arg.substring("--".length(), equal);
			System.setProperty(key, arg.substring(equal + 1));
		}
	}

	private static final String NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY = "<TALEND_NULL>";

	private final String[][] escapeChars = { { "\\\\", "\\" }, { "\\n", "\n" }, { "\\'", "\'" }, { "\\r", "\r" },
			{ "\\f", "\f" }, { "\\b", "\b" }, { "\\t", "\t" } };

	private String replaceEscapeChars(String keyValue) {

		if (keyValue == null || ("").equals(keyValue.trim())) {
			return keyValue;
		}

		StringBuilder result = new StringBuilder();
		int currIndex = 0;
		while (currIndex < keyValue.length()) {
			int index = -1;
			// judege if the left string includes escape chars
			for (String[] strArray : escapeChars) {
				index = keyValue.indexOf(strArray[0], currIndex);
				if (index >= 0) {

					result.append(keyValue.substring(currIndex, index + strArray[0].length()).replace(strArray[0],
							strArray[1]));
					currIndex = index + strArray[0].length();
					break;
				}
			}
			// if the left string doesn't include escape chars, append the left into the
			// result
			if (index < 0) {
				result.append(keyValue.substring(currIndex));
				currIndex = currIndex + keyValue.length();
			}
		}

		return result.toString();
	}

	public Integer getErrorCode() {
		return errorCode;
	}

	public String getStatus() {
		return status;
	}

	ResumeUtil resumeUtil = null;
}
/************************************************************************************************
 * 87770 characters generated by Talend Open Studio for Data Integration on the
 * 4 février 2021 11:49:19 CET
 ************************************************************************************************/